﻿using FlowPreservation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace FlowDemoSimple
{
    /// <summary>
    /// Simple class to test preservation of causality chains over different scenarios in classic applications.
    /// Try setting breakpoints after await boundaries to see how causality is stored.
    /// </summary>
    class Program
    {
        static readonly SemaphoreSlim semaphore = new SemaphoreSlim(0);

        static void Main(string[] args)
        {
            FlowReservoir.Enroll();
            //OuterAsync().Wait();
            //FireAndForget();
            Task.WaitAll(Simple(), Loop());
        }

        async static Task Simple()
        {
            await Task.Delay(1);
            await Common();
        }

        async static Task Loop()
        {
            for (int i = 0; i < 10; i++)
                await Task.Delay(1);
            await Common();
        }

        async static Task Common()
        {
            await Task.Delay(1);
            semaphore.Wait();
            //while (true) { }
        }

        async static Task InnerAsync()
        {
            await Task.Delay(1);
        }

        async static Task OuterAsync()
        {
            await InnerAsync();
        }

        async static void FireAndForget()
        {
            await Task.Delay(1);
        }
    }
}
