﻿using FlowPreservation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace FlowPreservation
{
    /// <summary>
    /// Graph node
    /// </summary>
    class StackGraphNode
    {
        private static int idCounter = 0;

        public StackGraphNode(string frame, int id = 0)
        {
            this.Frame = frame;
            this.Id = id == 0 ? Interlocked.Increment(ref idCounter) : id;
            this.Links = new HashSet<StackGraphNode>();
        }

        /// <summary>
        /// Frame text
        /// </summary>
        public string Frame { get; set; }

        /// <summary>
        /// Frame id (only needed to store it in dgml)
        /// </summary>
        public int Id { get; private set; }

        /// <summary>
        /// Links
        /// </summary>
        public ICollection<StackGraphNode> Links { get; set; }
    }
}
