﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlowPreservationPerfTests
{
    /// <summary>
    /// Runs a series of performance tests
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            const string logFile = "perf.txt";
            File.Delete(logFile);
            Trace.Listeners.Clear();
            Trace.Listeners.Add(new TextWriterTraceListener(logFile));
            var perfTests = new PerfTests();
            perfTests.TestStackTracePerf();
            perfTests.TestStackTracePerfAwaitSync().Wait();
            perfTests.TestStackTracePerfYield().Wait();
            perfTests.TestStoragePerf().Wait();
            perfTests.TestAsyncLocalPerf().Wait();
            Console.WriteLine("Done!");
            if (Debugger.IsAttached)
                Console.ReadLine();
        }
    }
}
