﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlowPreservation
{
    /// <summary>
    /// Extensions class that allows for combining actions
    /// </summary>
    static class AppendableExtensions
    {
        /// <summary>
        /// Combines two actions
        /// </summary>
        /// <param name="preAction">Action to execute first</param>
        /// <param name="postAction">Action to execute second</param>
        /// <returns>A composition of two actions</returns>
        public static Action Append(this Action preAction, Action postAction)
        {
            return () =>
            {
                preAction();
                postAction();
            };
        }
    }
}
