﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Threading.Tasks;
using FlowPreservation;
using System.Threading;
using System.Diagnostics;
using System.Reflection;

namespace FlowPreservationTests
{
    [TestClass]
    public class AwaitTests
    {
        [TestMethod]
        async public Task TestNested()
        {
            await Methods.NestedOuter();
            AssertEx.StackHasRoot();
        }

        [TestMethod]
        async public Task TestLoopTwoDelays()
        {
            await Methods.Loop();
            AssertEx.StackHasRoot();
        }

        [TestMethod]
        async public Task TestFlakiness()
        {
            await Methods.Flaky(10000);
            AssertEx.StackHasRoot();
        }

        [TestMethod]
        public void TestFork()
        {
            var t = Task.Run(new Func<Task>(Methods.FirstAsync));
            SpinWait.SpinUntil(() => t.IsCompleted);
            AssertEx.StackHasRoot();
        }
    }
}
