﻿using FlowPreservation;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlowPreservationTests
{
    [TestClass]
    public class CombinatorTests
    {
        [TestMethod]
        async public Task TestWhenAny()
        {
            await Task.WhenAny(Methods.InfiniteAsync(), Methods.FirstAsync());
            AssertEx.StackHasRoot();
            AssertEx.NotOnStack(Methods.InfiniteAsync);
        }

        [TestMethod]
        async public Task TestWhenAll()
        {
            await Task.WhenAll(Methods.FirstAsync(), Methods.SecondAsync());
            AssertEx.StackHasRoot();
        }

        [TestMethod]
        async public Task TestContinueWith()
        {
            await await Methods.FirstAsync().ContinueWith(async t => await Methods.SecondAsync());
            AssertEx.StackHasRoot();
        }

        [TestMethod]
        async public Task TestContinueWhenAll()
        {
            await Task.Factory.ContinueWhenAll(new[] { Methods.FirstSimple(), Methods.SecondSimple() }, tt => { });
            AssertEx.StackHasRoot();
        }
    }
}
