﻿using FlowPreservation;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading.Tasks.Dataflow;

namespace FlowPreservationTests
{
    [TestClass]
    public class DataFlowTests
    {
        [TestMethod]
        async public Task TestChainedBlocks()
        {
            var action = new ActionBlock<int>(new Func<int, Task>(Methods.SecondBlockAction));
            var transform = new TransformBlock<int, int>(new Func<int, Task<int>>(Methods.FirstBlockAction));
            transform.LinkTo(action);
            await transform.SendAsync(0);
            AssertEx.StackHasRoot();
            transform.Complete();
            await transform.Completion;
            AssertEx.StackHasRoot();
            action.Complete();
            await action.Completion;
            AssertEx.StackHasRoot();
        }
    }
}
