﻿using EnvDTE;
using EnvDTE80;
using FlowPreservation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.ExceptionServices;
using System.Text;
using System.Threading.Tasks;

namespace FlowViewer
{
    /// <summary>
    /// Helps run statements in Command window
    /// </summary>
    class CommandHelper
    {
        private readonly DTE2 dte;

        public CommandHelper(DTE2 dte)
        {
            this.dte = dte;
        }

        public CommandWindow CommandWindow
        {
            get { return dte.ToolWindows.CommandWindow; }
        }

        /// <summary>
        /// Execute statement and get result
        /// </summary>
        /// <param name="statement">Statement</param>
        /// <returns>Result</returns>
        public string ExecuteStatement(string statement)
        {
            CommandWindow.Clear();
            int offset = CommandWindow.TextDocument.EndPoint.AbsoluteCharOffset;
            dte.Debugger.ExecuteStatement(statement);
            var point = CommandWindow.TextDocument.StartPoint.CreateEditPoint();
            point.MoveToAbsoluteOffset(offset - 1);
            var text = point.GetText(CommandWindow.TextDocument.EndPoint);
            text = text.TrimEnd('>').TrimEnd();
            return text;
        }
    }
}
